% DFLINK(6) | Games
% Sven Bartscher
% 2017-11-24

# NAME

dflink - link a Dwarf Fortress runtime directory

# SYNOPSIS

**dflink** [**-h**] *TARGET* *LIBDIR* *DATADIR*...

# DESCRIPTION

**dflink** places files and symlinks taken from LIBDIR and one or more
DATADIRs in TARGET such that dwarf fortress can be run from TARGET.

When starting the dwarf fortress executable it expects to find
supporting files and libraries relative to the location of
the executable. When installing Dwarf Fortress into system directories
according to the File System Hierarchy Standard, Dwarf Fortress will
normally not be able to find them anymore. To mitigate this **dflink**
creates a symlink to the Dwarf Fortress executable and its supporting
files in TARGET so that the executable, when run from TARGET, can find
all its supporting files.

When called **dflink** will do the following things:

 1. The DATADIRS will be search from first to last for a file
    *DATADIR/data/index*. The first occurring file will be copied to
    *TARGET/data/index*. This is because Dwarf Fortress expects this
    file to be present and modifiable.
 2. Link *LIBDIR/df* to *TARGET/df* and *LIBDIR/Dwarf_Fortress* to
    *TARGET/lib/Dwarf_Fortress*. If a link cannot be created due to a
    file already existing in its location the link will not be created
    and the original file will not be changed to avoid destroying
    data.
 3. A list of the symlinks created on the previous run of **dflink**
    will be read from *TARGET/dflinked.json*. All links from that list
    that are still links (thus have not been replaced by real files)
    and still point to the location *dflink* remembers to have linked
    them to, are deleted if there is no file in the current DATADIRs
    that would have been linked to this location. This is supposed to
    clean out links to files that have been removed from the DATADIRs
    while preserving manual changes.
 4. All files found in all DATADIRs are linked to TARGET. Directories
    are created as appropriate. If two or more DATADIRs contain a file
    with the same path (relative to the DATADIR) the file from the
    DATADIR listed first on the command line takes precedence. If
    an existing link is encountered while attempting to create another
    link the old link is replaced. If anything else than a link is
    encountered while attempting to create a link, the link is not
    created and the original file is left as it is to prevent
    destroying data. If a link is not created for some reason, it is
    still recorded in *TARGET/dflinked.json*
 5. The list of links created in the last step is recorded in
    *TARGET/dflinked.json*.

# OPTIONS

## -h
Show this help text

# FILES

## *TARGET/dflinked.json*
A list in JSON format of links created by **dflink** and where they
were linked to.

# SEE ALSO
dwarf-fortress(6)
